JD Edwards Anypoint&trade; Studio Connector Demo (Poll EDI Events)
==================================================================

## Introduction

The current demo application provides a simple workflow to capture Order Acknowledgments (855/ORDRSP) generated by JD Edwards and save it in a local folder as json file.

## Prerequisites

* Java 7
* Anypoint Studio 5.4.x
* Mule Runtime 3.7.0 EE or higher
* DataWeave
* JDE Connector User manual has been read
* JDE bundle must be created. (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Generate Bundle_)
* JDE standards ini files (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Copy JDE ini Files to the Projet_)
* JDE Enterprise Server is reachable from your location
* Mule Object Store Module Mule Studio Extension installed. Version 1.3.3 * . It allows access and manipulate object stores within Mule.

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Menu](images/jde_connection_config01.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/jde_connection_config02.png)

* Click **Finish**.  
* Set Cookbook credentials inside the file `src/main/app/mule-app.properties`.

```
jde.user=<JDE_USER>
jde.password=<JDE_PASSWORD>
jde.environment=<JDE_ENVIRONMENT>
jde.role=<JDE_ROLE>
jde.imagefoldercache=<LOCAL_FOLDER>
```

* Copy **JDE ini Files** inside the Project.

Put the files inside the project folder in the folder:

* source/main/resource
* root folder of the project

![Test Connection](images/jde_connection_config06.png)


* Inside the Global Elements view, double-click the **JDE Configuration** component.

![Test Connection](images/jde_connection_config03.png)

Add JDE Bundle jar file.

![Test Connection](images/jde_connection_config04.png)

Click "Test Connection".

![Test Connection](images/jde_connection_config05.png)

* A successful message should pop-up.

![Test Connection](images/jde_connection_config07.png)

* Save the project and from the Project Folder, Select **Run as Mule Application**

## About the flows

**1. ProcessJDEEDIEvents:** poll EDI events that it came from EDI transactions generated by  Batch EDI - P.O. Acknowledgment Transaction (855).

![Flow HMTL Form](images/jde_connection_flow01.png)

**2. jde_ProcessTransactions:** it takes transactions from mule queue and it save each customer transaction in local folder. At the end of the workflow it saves the last EDI batch number. This EDI batch number is used by the previous workflow to know what is the last record processed.

![Flow Get](images/jde_connection_flow02.png)

**3. Choice_Exception_Strategy:** global exception strategy that handles every exception that may arise at runtime and forwards it to the HTML form for better troubleshooting in the front-end side.

![Flow 6 Exception](images/jde_connection_flow04.png)

## Configure JD Edwards Application.

**1. Create a new UBE version for R42565 or use standard XJDE0003 version**

![Flow HMTL Form](images/edi_01.png)

and configure Processing Options:

![Flow HMTL Form](images/edi_02.png)

**2. Configure Flat File Cross-Reference (P47002)**

The last configuration that is needed is inform to JDE connector the EDI outbound:

Using "Flat File Cross-Reference (P47002)" form "Work With Flat File Cross-Reference" adds the following record:

![Flow HMTL Form](images/edi_03.png)

* Table: F47026 - Record Type: 1 Header

* Table: F47027 - Record Type: 2 Detail

* Table: F4706 -  Record Type: 6 Address

* Table: F4714 -  Record Type: 7 Header Text

* Table: F4715 -  Record Type: 8 Detail Text


## Run the demo


* Enter a Sales Order and invoke UBE R42565 XJDE0003 [ Batch EDI - P.O. Acknowledgment Transaction (855) ] for the order generated.

![Flow HMTL Form](images/event_jde30.png)

![Flow HMTL Form](images/event_jde31.png)

![Flow HMTL Form](images/event_jde32.png)

![Flow HMTL Form](images/event_jde33.png)

![Flow HMTL Form](images/event_jde34.png)

* Go to local folder **output** over project root and see the transaction captured.

![Flow HMTL Form](images/event_jde15.png)

![Flow HMTL Form](images/event_jde16.png)


* **Congratulations!** You have successfully run this demo. Continue exploring the connector by playing with other available [demos](http://modusintegration.github.io/mule-connector-jde/) or visiting the [JD Edwards Connector Documentation Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html) and  the [DevKit Cookbook Tutorial](http://mulesoft.github.io/mule-cookbook-tutorial).
